﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp22
{
    delegate void Mydel();
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            //writeAtoRichTextBox();
            richTextBox1.Clear();
            Thread t1 = new Thread(writeAfromThread);
            t1.Start();
            Thread t2 = new Thread(writeBfromThread);
            t2.Start();
        }

        public void writeAfromThreadv2()
        {
            Mydel d1 = writeAtoRichTextBox;
            lock (richTextBox1)
            {
                for (int i = 0; i < 20; i++)
                {
                    Thread.Sleep(500);
                    richTextBox1.Invoke(d1);
                }
            }
            
        }
        public void writeBfromThreadv2()
        {
            Mydel d1 = writeBtoRichTextBox;
            lock (richTextBox1)
            {
                for (int i = 0; i < 20; i++)
                {
                    Thread.Sleep(500);
                    richTextBox1.Invoke(d1);
                }
            }
            
        }
        public void writeAfromThread()
        {
            Mydel d1 = writeAtoRichTextBox;
            for(int i = 0; i < 20; i++)
            {
                Thread.Sleep(500);
                richTextBox1.Invoke(d1);
            }
        }
        public void writeBfromThread()
        {
            Mydel d1 = writeBtoRichTextBox;
            for (int i = 0; i < 20; i++)
            {
                Thread.Sleep(500);
                richTextBox1.Invoke(d1);
            }
        }
        public void writeAtoRichTextBox()
        {
            richTextBox1.AppendText("A");
        }
        public void writeBtoRichTextBox()
        {
            richTextBox1.AppendText("B");
        }

        private void button2_Click(object sender, EventArgs e)
        {
            richTextBox1.Clear();
            Thread t1 = new Thread(writeAfromThreadv2);
            t1.Start();
            Thread t2 = new Thread(writeBfromThreadv2);
            t2.Start();
        }
    }
}
